package Package1;

public class Cpc {

    static String returnNameClass(int pitch) {
        String[] notes = {"C", "C#", "D", "D#", "E", "F", "F#", "G", "G#", "A", "A#", "B"};
        return notes[pitch % 12];
    }

    static int returnOctave(int pitch) {
        return (pitch / 12);
    }

    public static void main(String[] args) {
        if (args.length != 2) {
            System.out.println("Numero di argomenti errato: sono richiesti 2 argomenti");
            System.exit(1);
        }
        int pitch1 = -1;
        int pitch2 = -1;
        try {
            pitch1 = Integer.parseInt(args[0]);
            pitch2 = Integer.parseInt(args[1]);
        } catch (NumberFormatException e) {
            System.out.println("Gli argomenti non sono di tipo numerico intero");
            System.exit(1);
        }

        System.out.println("La scrittura corrispondente al CPC " + pitch1 + " e' "
                + returnNameClass(pitch1) + returnOctave(pitch1));
        System.out.println("La scrittura corrispondente al CPC " + pitch2 + " e' " 
                + returnNameClass(pitch2) + returnOctave(pitch2));

        int distance = pitch2 - pitch1;
        String result = "La distanza in semitoni tra " + pitch1 + " e " + pitch2 
                + " risulta pari a " + Math.abs(distance) + " semitono/i";
        if (distance != 0)
            result += " in senso " + (distance >= 0 ? "ascendente" : "discendente");
        System.out.println(result);
    }

}
