package Package1;


import javax.swing.JFrame;
import javax.swing.WindowConstants;
import com.jsyn.JSyn;
import com.jsyn.Synthesizer;
import com.jsyn.data.FloatSample;
import com.jsyn.unitgen.*;
import com.jsyn.util.SampleLoader;
import java.io.File;
import java.io.IOException;

public class NewClass extends JFrame {

    Synthesizer synth;
    UnitOscillator osc;
    LineOut lineOut;
    VariableRateDataReader samplePlayer;

    public NewClass(String title, int width, int height) throws IOException, InterruptedException {
        super(title);
        pack();
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        setSize(width, height);
        setVisible(true);

        // Create a context for the synthesizer.
        synth = JSyn.createSynthesizer();

        // Start synthesizer using default stereo output at 44100 Hz.
        synth.start();
        // Add an output mixer.
        synth.add(lineOut = new LineOut());
        lineOut.start();

        // Create a float array to contain audio data.
        float[] data = new float[4410];
        // Fill it with sawtooth data. */
        float value = 1.0f;
        for (int i = 0; i < data.length; i++) {
            data[i] = value;
            if (i  % 441 == 0) {
                value = -value;
            }
        }
        // Generate sample directly from the data.
        FloatSample sample = new FloatSample(data);
        synth.add(samplePlayer = new VariableRateMonoReader());
        samplePlayer.rate.set(sample.getFrameRate()* 8);
        samplePlayer.output.connect(0, lineOut.input, 0);
        samplePlayer.dataQueue.queueLoop(sample, 0, sample.getNumFrames(), 10);
        do {
            synth.sleepFor(1.0);
        } while (samplePlayer.dataQueue.hasMore());

//        File sampleFile = new File("beep.wav");
//        FloatSample sample = SampleLoader.loadFloatSample(sampleFile);
//        if (sample.getChannelsPerFrame() == 1) {
//            synth.add(samplePlayer = new VariableRateMonoReader());
//            samplePlayer.output.connect(0, lineOut.input, 0);
//        } else if (sample.getChannelsPerFrame() == 2) {
//            synth.add(samplePlayer = new VariableRateStereoReader());
//            samplePlayer.output.connect(0, lineOut.input, 0);
//            samplePlayer.output.connect(1, lineOut.input, 1);
//        } else {
//            throw new RuntimeException("Can only play mono or stereo samples.");
//        }
//        
//        samplePlayer.rate.set(sample.getFrameRate());
//
//        // We only need to start the LineOut. It will pull data from the sample player.
//        lineOut.start();
//
//        // We can simply queue the entire file.
//        // Or if it has a loop we can play the loop for a while.
//        if (sample.getSustainBegin() < 0) {
//            System.out.println("queue the sample");
//            samplePlayer.dataQueue.queue(sample);
//        } else {
//            System.out.println("queueOn the sample");
//            samplePlayer.dataQueue.queueOn(sample);
//            synth.sleepFor(8.0);
//            System.out.println("queueOff the sample");
//            samplePlayer.dataQueue.queueOff(sample);
//        }
//
//        // Wait until the sample has finished playing.
//        do {
//            synth.sleepFor(1.0);
//        } while (samplePlayer.dataQueue.hasMore());
//
//        synth.sleepFor(0.5);
    }

    public static void main(String[] args) throws IOException, InterruptedException {
        NewClass frame = new NewClass("", 500, 400);
    }
}
