package jMusic;

import jm.JMC;
import jm.util.*;
import jm.music.data.*;
import jm.audio.*;

public class RandomAudio implements JMC {

    public static void main(String[] args) {
        int N = 20;
        
        int[] fib = new int[N];
        fib[0] = 1;
        fib[1] = 1;
        for (int i = 2; i < N; i++)
            fib[i] = fib[i-1] + fib[i-2];
        
        Score s = new Score("RandomAudio");
        
        Phrase[] phrases = new Phrase[2];
        for (int i = 0; i < 2; i++)
            phrases[i] = new Phrase();

        SineInst inst1 = new SineInst(44100);
        PluckInst inst2 = new PluckInst(44100);
        Instrument[] instruments = {inst1, inst2};

        for (int i = 0; i < N; i++) {
            int pitchDelta = PENTATONIC_SCALE[fib[i] % 5];
            int pitch = C4 + pitchDelta;
            double rhythmValue = 1 + Math.random();
            int dynamic = 60 + (int)(61 * Math.random());
            double pan = Math.random();
            int instr = fib[i] % 2;
            for (int j = 0; j < 2; j++) {
                if (j == instr)
                    phrases[j].add(new Note(pitch, rhythmValue, dynamic, pan));
                else
                    phrases[j].add(new Rest(rhythmValue));
            }
        }
        
        Part[] parts = new Part[2];
        for (int i = 0; i < 2; i++)
            parts[i] = new Part(phrases[i], "Part" + i, i);
        s.addPartList(parts);

        View.print(s);
        //write au
        Write.au(s, "RandomAudio.au", instruments);
    }
}
