package jSyn;

import com.jsyn.JSyn;
import com.jsyn.Synthesizer;
import com.jsyn.data.FloatSample;
import com.jsyn.unitgen.*;
import com.jsyn.util.SampleLoader;
import java.io.File;
import java.io.IOException;

public class PlaySample {
    Synthesizer synth;
    VariableRateDataReader samplePlayer;
    LineOut lineOut;

    private void test() throws IOException, InterruptedException {
        synth = JSyn.createSynthesizer();
        synth.start();
        synth.add(lineOut = new LineOut());
        File sampleFile = new File("beep.wav");
        FloatSample sample = SampleLoader.loadFloatSample(sampleFile);
        if (sample.getChannelsPerFrame() == 1) {
            synth.add(samplePlayer = new VariableRateMonoReader());
            samplePlayer.output.connect(0, lineOut.input, 0);
        } else if (sample.getChannelsPerFrame() == 2) {
            synth.add(samplePlayer = new VariableRateStereoReader());
            samplePlayer.output.connect(0, lineOut.input, 0);
            samplePlayer.output.connect(1, lineOut.input, 1);
        } else {
            throw new RuntimeException("Sono supportati solo file mono o stereo");
        }
        
        samplePlayer.rate.set(sample.getFrameRate());

        lineOut.start();

        System.out.println("queue the sample");
        samplePlayer.dataQueue.queue(sample);

        do {
            synth.sleepFor(1.0);
        } while (samplePlayer.dataQueue.hasMore());

        synth.sleepFor(0.5);
    }

    public static void main(String[] args) throws IOException, InterruptedException {
        new PlaySample().test();
    }
}